#ifndef __CALCULATION_H_INCLUDED__
#define __CALCULATION_H_INCLUDED__

typedef struct{
	int size;
	double *v;
}Vector;

typedef struct{
	int height;
	int width;
	double *a;
}Matrix;

Vector *CreateVector(int size);
void FreeVector(Vector* vector);

Matrix *CreateMatrix(int width, int height);
void FreeMatrix(Matrix* matrix);
//
//LU$BJ,2r!#9TNs(Bm$B$r2<;03Q9TNs$H>e;03Q9TNs$KJ,2r%Y%/%H%k(Bv$B$O9T$r8r49$9$k$H$-$K9g$o$;$F8r49$9$k!#(B
int* LU(Matrix* m);
//LU$BJ,2r$r;H$C$FO"N)0l<!J}Dx<0$r2r$/!#(Bmatrix$B$K$O$=$l$>$l$N78?t$N9TNs!#(Bans$B$K$OJ}Dx<0$N2r$,F~$k!#(B
void FBSubstitution(Matrix *matrix, Vector *ans);
#endif /* __CALCULATION_H_INCLUDED__ */
